<?php

namespace Teknisa\FIN\Controllers;

use Teknisa\FIN\Controllers\TeknisaCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\Manager;

class TiporeceTiporece extends TeknisaCrud{

    protected $dataSourceName = 'tiporece_tiporece';
    protected $dataSourceNameToSave = 'tiporece';

	public function __construct($crudService, $parameterBag, Manager $dataSourceManager) {
		parent::__construct($crudService, $parameterBag);
        $this->dataSourceManager = $dataSourceManager;
	}
	
	public function salvar(DTO\Request\DataSet $request, DTO\Response $response) {
		$this->dataSourceName = 'tiporece_tiporece';
        try {
            $dataSet = $request->getDataSet();
            $dataSet->setDataSourceName($this->dataSourceName);
            $persistedRows = $this->dataSourceManager->persist($dataSet);
            $response->addDataSet(new DataSet($this->dataSourceName, $persistedRows));
        } catch (\Exception $e) {
            $response->setError(new DTO\Response\Error($e->getMessage(), $e->getCode(), $e->getTraceAsString()));
        }
	}
	
    public function save(DTO\Request $request, DTO\Response $response) {
    	$this->dataSourceName = 'tiporece_tiporece';
    	$dataSet = $request->getDataSet();
    	$rows = $dataSet->getRows();
    	$row = $rows[0];
    	
		if (!$row["__is_new"]) {
			if (($this->confereOrdem($row))){
				$this->salvar($request, $response);
			} else{
				$response->setError(new DTO\Response\Error("Ordem do Troco já Cadastrada.", 1));
			}
		} else {
			$condition = array(
				array(
			   		"value" => $row["NRORG"],
			   		"operator" => "=",
			   		"columnName" => "NRORG"
			   	),
			   	array(
			   		"value" => $row["CDTIPORECE"],
			   		"operator" => "=",
			   		"columnName" => "CDTIPORECE"
			   	)
			);
			$rowsFilter = $this->getRows($this->dataSourceName, $condition);
			if(empty($rowsFilter)){
				if (($this->confereOrdem($row))){
					parent::save($request, $response);
				} else{
					$response->setError(new DTO\Response\Error("Ordem do Troco já Cadastrada.", 1));
				}
			} else {
				$response->setError(new DTO\Response\Error("Recebimento já Cadastrado.", 1));
			}
		}
	}
	
	public function saveEndereco (DTO\Request $request, DTO\Response $response) {
		$this->dataSourceName = 'ger25940_tipo_recebimento_endereco';
        parent::save($request,$response);
	}
	
	public function confereOrdem ($row) {
		$condition = array(
			array(
				"value" => $row["NRORG"],
			   	"operator" => "=",
				"columnName" => "NRORG"
			),
			array(
		   		"value" => $row["NRORDTROCO"],
		   		"operator" => "=",
		   		"columnName" => "NRORDTROCO"
		   	)
		);
		$rowsFilter = $this->getRows($this->dataSourceName, $condition);
		if(empty($rowsFilter)){
			return true;
		} else if ($rowsFilter[0]["CDTIPORECE"] == $row["CDTIPORECE"]) {
			return true;
		} else {
			return false;
		}
	}
	public function getRows ($dataSourceName, $condition) {
		$filterCriteria = new FilterCriteria($dataSourceName, $condition);
		$newFilterCriteria = $this->crudService->populateParameterBag($filterCriteria, $this->parameterBagColumns);
		$dataSetFilter = $this->dataSourceManager->findBy($newFilterCriteria);
		$filterRows = $dataSetFilter->getRows();
		return $filterRows;
	}
	
	public function findEndereco (DTO\Request $request, DTO\Response $response) {
		$this->dataSourceName = 'ger25940_tipo_recebimento_endereco';
        parent::find($request,$response);
	}
}